// Compute the average of a user-specified file of data values 	
	
import java.util.*;
import java.io.*;	
	
public class FileAverage {	
	// main(): application entry point	
	public static void main(String[] args) throws IOException {	
		// set up standard input stream	
		Scanner stdin = new Scanner( System.in );	
	
		// determine filename	
		System.out.print("Filename: ");	
		String filename = stdin.nextLine();	
	
		// open file stream for text processing	
		Scanner fileIn = new Scanner( new File(filename) ) ;
	
		// initially no values have been processed	
		int valuesProcessed = 0;	
		double valueSum = 0;	
	
		while ( fileIn.hasNext() ) {           // did we get it	
			// convert string to numeric value	
			double value = fileIn.nextDouble() ;
			// add value to running total	
			valueSum += value;	
			// processed another total	
			++valuesProcessed;	
		}	
	
		// close up file	
		fileIn.close();	
	
		// ready to compute average	
		if (valuesProcessed > 0) {	
			double average = valueSum / valuesProcessed;	
			System.out.println("Average file data value: " + average);	
		}	
		else {	
			System.err.println(filename + ": no values to average");	
		}	
	}	
}	
	
